#!/usr/bin/perl 

##### ##### ##### ##### ##### ##### ##### ##### 
#####
##### but : recoit en argument un nom ".jps", le traite et l'imprime 
##### sur la sortie standard ou sur le fichier ".ps" associe
#####
##### ##### ##### ##### ##### ##### ##### ##### 

$pi = 3.14159265358979;

############################################
###                                      ###
###           no de version              ###
###                                      ###
############################################

$version = "jps2ps version 0.05b, 17 fvrier 2003";

############################################
###                                      ###
### localisation des differents fichiers ###
###                                      ###
############################################

### le repertoire d'installation de BBgraf 
$BBGRAF_DIR = "/var/www/syracuse/bbgraf/";
## $BBGRAF_DIR = "/var/www/syracuse/bbgraf/";

### le repertoire d'installation de jps2ps
$JPS2PS_DIR = $BBGRAF_DIR . "jps2ps/";

############################################
###                                      ###
### lecture de la ligne de commande      ###
###                                      ###
############################################

## but : analyse les arguments recus
## 4 arguments pris en compte : -a, -pst, -lpst, et le nom du fichier

##print "@ARGV \n";     ## la liste des arguments
$nbarg = $#ARGV;  ## le nb d'arguments

## un hachage pour stocker les options
## %options ("" => "")

$source = "-";

for $i (0 .. $nbarg) {
    $argument = $ARGV[$i];
    if ($argument =~ /^-a/) {
        $sortieimposee = 1;
    }
    if ($argument =~ /^-pst/) {
        $sortiepst = 1;
    }
    if ($argument =~ /^-lpst/) {
        $sortielpst = 1;
    }
    if ($argument !~ /^-/) {
        $source = $argument;
        ## si le nom de fichier n'a pas de suffixe, on rajoute '.jps'
        if ($source !~ /\./) {
            $source = $source . "\.jps";
        };
    }
}


##$source = "@ARGV[0]";

require $JPS2PS_DIR . "labels.pl";

##### ##### ##### ##### ##### ##### ##### ##### 
#####
##### les fichiers .pps 
#####
##### ##### ##### ##### ##### ##### ##### ##### 

require $JPS2PS_DIR . "listpps.pl";

##### ##### ##### ##### ##### ##### ##### ##### 
##### 
##### On definit le tableau des ordres de priorite
##### 
##### ##### ##### ##### ##### ##### ##### ##### 

require $JPS2PS_DIR . "priorite.pl";

##### ##### ##### ##### ##### ##### ##### ##### 
#####
##### on definit le hachage des dependances
#####
##### ##### ##### ##### ##### ##### ##### ##### 

require $JPS2PS_DIR . "dephash.pl";

##### ##### ##### ##### ##### ##### ##### ##### 
#####
##### les instructions traitees a part (valeurs par defaut)
#####
##### ##### ##### ##### ##### ##### ##### ##### 

$xmin_str = "/xmin -6 def\n";
$xmax_str = "/xmax 6 def\n";
$ymin_str = "/ymin -6 def\n";
$ymax_str = "/ymax 6 def\n";
$border_str = "/border 7.5 def\n";
$xmin = -6;
$xmax = 6;
$ymin = -6;
$ymax = 6;
$border = 7.5;
$rotate = 0;
$angle_repere = 90;
$xunit = 0;
$yunit = 0;
## $width = 0;
## $height = 0;

$width_str = "/width 250 def\n";
$height_str = "/height 250 def\n";

## $width_str = "";
## $height_str = "";

##### ##### ##### ##### ##### ##### ##### ##### 
#####
##### analyse du source .jps
#####
##### ##### ##### ##### ##### ##### ##### ##### 

## temoins pour les lectures de setxrange et setyrange
## = 1 si pas lu, et 0 si deja lu
$xtem = 1;
$ytem = 1;

$format = "";        ## initialisation du rapport width/height
$xyrapport = 1;      ## initialisation du rapport x/y

## lecture du source, et stockage ds le tableau @le_source
$i = 0;
open (SRC, $source) or die "ouverture du fichier $source impossible";
while (<SRC>) {
    @le_source [$i] = $_;
    $i = $i + 1;
};
close (SRC);

## ici, on traite la saisie des donnees pour le  calcul de la BB
## ainsi que le scan pour le traitement des dependances

foreach $line (@le_source) {
    $ligne = $line;
    ## on elimine les commentaires
    if ($ligne =~ /%/) {
        $ligne =~ s/%.*$//;
    };
    if ($ligne =~ /\t/) {
        $ligne =~ s/\t/ /g;
    };
    ## traitement des mots cles particuliers (format image)
    if ($ligne =~ /setunit/) {
          ($xunit = $ligne) =~ s/^([0-9-.]*) ([0-9.]*) .*[\n]?$/$1/;
          ($yunit = $ligne) =~ s/^([0-9-.]*) ([0-9.]*) .*[\n]?$/$2/;
    };
    if ($ligne =~ /setxunit/) {
           $xunit = $ligne;
           $xunit =~ s/ setxunit.*[\n]?$//;
    };
    if ($ligne =~ /setyunit/) {
           $yunit = $ligne;
           $yunit =~ s/ setyunit.*[\n]?$//;
    };
    if ($ligne =~ /setxrange/ and $xtem =~ 1) {
           $xmin_str = "";
           $xmax_str = "";
	   $xtem = 0;
           ($xmin = $ligne) =~ s/^([0-9-.]*) ([0-9.]*) .*[\n]?$/$1/;
           ($xmax = $ligne) =~ s/^([0-9-.]*) ([0-9-.]*) .*[\n]?$/$2/;
           $setxrange_str = $ligne;
    };
    if ($ligne =~ /setyrange/ and $ytem =~ 1) {
           $ymin_str = "";
           $ymax_str = "";
	   $ytem = 0;
           ($ymin = $ligne) =~ s/^([0-9-.]*) ([0-9.]*) .*[\n]?$/$1/;
           ($ymax = $ligne) =~ s/^([0-9-.]*) ([0-9-.]*) .*[\n]?$/$2/;
           $setyrange_str = $ligne;
    };
    if ($ligne =~ /^\/xmin/) {
	$xmin_str = $ligne;
        ($xmin = $xmin_str) =~ s/\/xmin[ {]*(.*)[ }]*def.*\n/$1/
    };
    if ($ligne =~ /^\/xmax/) {
	$xmax_str = $ligne;
        ($xmax = $xmax_str) =~ s/\/xmax[ {]*(.*)[ }]*def.*\n/$1/;
    };
    if ($ligne =~ /^\/ymin/) {
	$ymin_str = $ligne;
        ($ymin = $ymin_str) =~ s/\/ymin (.*) def.*\n/$1/;
    };
    if ($ligne =~ /^\/ymax/) {
	$ymax_str = $ligne;
        ($ymax = $ymax_str) =~ s/\/ymax (.*) def.*\n/$1/;
    };
    if ($ligne =~ /^\/border /) {
	$border_str = $ligne;
        ($border = $border_str) =~ s/\/border (.*) def.*\n/$1/;
    };
    if ($ligne =~ /setborder/) {
	$border_str = $ligne;
        ($border = $border_str) =~ s/ setborder.*[\n]?$//;
    };
    if ($ligne =~ /setxyrapport/) {
        $xyrapport = $ligne;
        $xyrapport =~ s/ setxyrapport.*[\n]?$//;
    };
    if ($ligne =~ /setformat/) {
        $format = $ligne;
        $format =~ s/ setformat.*[\n]?$//;
    };
    if ($ligne =~ /setrotate/) {
        $rotate = $ligne;
        $rotate =~ s/ setrotate.*[\n]?$//;
    };
    if ($ligne =~ /setangle_repere/) {
        $angle_repere = $ligne;
        $angle_repere =~ s/ setangle_repere.*[\n]?$//;
    };
    if ($ligne =~ /^\/width/) {
           $width_str = $ligne;
           $width = $ligne;
	   $width =~ s/^\/width[ ]*(.*) def.*[\n]?$/$1/;
    };
    if ($ligne =~ /setwidth/) {
           $width_str = $ligne;
           $width = $ligne;
           $width =~ s/ setwidth.*[\n]?$//;
    };
    if ($ligne =~ /^\/height/) {
           $height_str = $ligne;
           $height = $ligne;
	   $height =~ s/^\/height[ ]*(.*) def.*[\n]?$/$1/;
    };
    if ($ligne =~ /setheight/) {
           $height_str = $ligne;
           ($height = $ligne) =~ s/ setheight.*[\n]?$//;
    };

    ### puis traitement standard
    ###
    ## on elimine les commentaires

    if ($ligne =~ /%/) {
           $ligne =~ s/%.*$//;
    }
    if ($ligne =~ /\(|\)|{|}|\[|\]|\//) {
           $ligne =~ s/\(|\)|{|}|\[|\]|\// /g;
    }
    if ($ligne =~ /  /) {
           $ligne =~ s/  / /g;
    }    
   $ligne =~ s/\r\n//;
   $ligne =~ s/\n//;
   @contenu = split (/ /, $ligne); 
   foreach $mot (@contenu) {
        if ($mot =~ /[a-zA-Z]/) {
## modif 01/07/00   while ($mot =~ /[0-9]/) {$mot =~ s/[0-9]//;};
            if ($mot =~ /[0-9]/) {$mot =~ s/[0-9]//g;};
##            ### impression pour deboguage
##            print "%%%%% $mot=="."\n";
            ##### on fixe les dependances
            foreach $dep (@{ $dependances {$mot} }) {
               $besoin {$dep} = 1;
##               ### impression pour deboguage
##               print "%% === $dep\n";
            }
        }
   }
};

#close FICHIER;

## on force la selection de tracerepere et de mulv
$besoin {tracerepere} = 1;
            foreach $dep (@{ $dependances {tracerepere} }) {
                $besoin {$dep} = 1;};
$besoin {mulv} = 1;
            foreach $dep (@{ $dependances {mulv} }) {
                $besoin {$dep} = 1;};

## ##### impression pour deboguage
## print "%%%%% ======= on trouve =======\n";
## print '%' x 80 . "\n";
## 
## foreach $word (@cles) {
##    print "%% " . "$word   " . $besoin {$word} . "\n";
## }

##### ##### ##### ##### ##### ##### ##### ##### 
##### 
##### Si necessaire, on calcule les donnees manquantes
##### 
##### ##### ##### ##### ##### ##### ##### ##### 

## ##### impression pour deboguage
## print "%% xmin = $xmin \n";
## print "%% xmax = $xmax \n";
## print "%% ymin = $ymin \n";
## print "%% ymax = $ymax \n";
## print "%% scale = $scale \n";
## print "%% width = $width \n";
## print "%% height = $height \n";
## print "%% xyrapport = $xyrapport"."\n";
## print "%% format = $format"."\n";
## print "%% xunit = $xunit"."\n";
## print "%% yunit = $yunit"."\n";
##  print "%% angle_repere = $angle_repere"."\n";
##  print "%% angle_repere = " . sin ($angle_repere * $pi / 180) ."\n";

$dx = $xmax - $xmin;
$dy = $ymax - $ymin; #* sin ($angle_repere * $pi / 180);

## les xunit et yunit sont prioritaires
if ($xunit != 0) {
    $width = $dx * $xunit;
    $width_str = "/width $width def\n";
};
if ($yunit != 0) {
    $height = $dy * $yunit;
    $height_str = "/height $height def\n";
};

## Ici, on a recupere toutes les donnees de format presentes dans le source jps. 
## Les variables xmin, xmax, ymin, ymax, border et xyrapport sont initialisees.

##### calcul des donnes manquantes pour la Bounding Box si necessaire 
##### on veut qu(il y ait au moins une des 2 variables $width et $height
##### qui soit initialisee

if ((not $width) and (not $height)) {
    if ($dx > $dy) {
	$height = 250;
    }
    else {
	$width = 250;
    }
}

if ($width and $height) {
    ## rien a faire
} 
elsif ($format) {
    if ($width) {
        ## on a $width et $format
        $height = $width / $format;
        $height_str = "/height $height def\n";
    } else {
        ## on a $height et $format
        $width = $height * $format;
        $width_str = "/width $width def\n";
    }
}
else {
    if ($width) {
        $height = $dy * sin ($angle_repere * $pi / 180) * $width / ($xyrapport * $dx);
        $height_str = "/height $height def\n";
    }
    else {
        $width = $height * ($xyrapport * $dx) / ($dy * sin ($angle_repere * $pi / 180));
        $width_str = "/width $width def\n";
    }
}

## ##### on impose egalement width et height < 1000 pour eviter des problemes
## ##### lors de la convertion au format jpeg par les mageMagick
## if ($width > 1000) {
##     $width = 1000;
## };
## if ($height > 1000) {
##     $height = 1000;
## };

## ##### impression pour deboguage
## 
## print "%% xmin = $xmin \n";
## print "%% xmax = $xmax \n";
## print "%% ymin = $ymin \n";
## print "%% ymax = $ymax \n";
## print "%% scale = $scale \n";
## print "%% width = $width \n";
## print "%% height = $height \n";
## print "%% border = $border \n";
## print "%% xyrapport = $xyrapport"."\n";
## print "%% format = $format"."\n";

### les dimensions de la Bounding Box
### (probleme ici si border, width ou height n'ont pas ete lus correctement)

$bbx = $width + 2 * $border;
$bby = $height + 2 * $border;
### puis on tronque
$bbx = (int ($bbx * 100)) / 100;
$bby = (int ($bby * 100)) / 100;

sub max {
    my ($x, $y) = @_;
    if ($x>$y) {
	return ($x);
    } else {
	return ($y);
    }
}

sub min {
    my ($x, $y) = @_;
    if ($x > $y) {
	return ($y);
    } else {
	return ($x);
    }
}

$alpha = $rotate * ($pi / 180);

## print ("bbx : $bbx\n");
## print ("bby : $bby\n");
## print ("rotate : $rotate,\n");
## print (sin ($alpha) . "\n");

$dlx = min (-$bby * sin ($alpha), 0);
$dlx = min ($dlx, $bbx * cos ($alpha));
$dlx = min ($dlx, $bbx * cos ($alpha) - $bby * sin ($alpha));
$dly = min ($bby * cos ($alpha), 0);
$dly = min ($dly, $bbx * sin ($alpha));
$dly = min ($dly, $bbx * sin ($alpha) + $bby * cos ($alpha));

## print ("dlx : $dlx\n");
## print ("dly : $dly\n");

$urx = max (-$bby * sin ($alpha), 0);
$urx = max ($urx, $bbx * cos ($alpha));
$urx = max ($urx, $bbx * cos ($alpha) - $bby * sin ($alpha));
$ury = max ($bby * cos ($alpha), 0);
$ury = max ($ury, $bbx * sin ($alpha));
$ury = max ($ury, $bbx * sin ($alpha) + $bby * cos ($alpha));

## print ("urx : $urx\n");
## print ("ury : $ury\n");

### la relative Bounding Box par rapport a l'origine du repere (utile pour PSTricks)
$botx = ($xmin * $width) / ($xmax - $xmin) - $border ;
$boty = ($ymin * $height) / ($ymax - $ymin) - $border ;
$topx = ($xmax * $width) / ($xmax - $xmin) + $border ;
$topy = ($ymax * $height) / ($ymax - $ymin) + $border ;
### puis on tronque
$botx = (int ($botx * 100)) / 100;
$boty = (int ($boty * 100)) / 100;
$topx = (int ($topx * 100)) / 100;
$topy = (int ($topy * 100)) / 100;
## print "%% botx = $botx \n";
## print "%% boty = $boty \n";
## print "%% topx = $topx \n";
## print "%% topy = $topy \n";
### unites pour PSTricks
$PSTxunit = (int (($width / $dx) * 100)) / 100 ;
$PSTyunit = (int (($height / $dy) * 100)) / 100 ;
### placement de la boite pour epsfbox dans PSTricks
$PSTOx = $xmin + ($dx/2);
$PSTOy = $ymin + ($dy/2);

##### ##### ##### ##### ##### ##### ##### ##### 
##### 
##### Impressions pour PSTricks
##### 
##### ##### ##### ##### ##### ##### ##### ##### 

if ($sortiepst or $sortielpst) {
    $dimptx = $bbx;
    $dimpty = $bby;
    ## on la calcule en mm
    $dimx = ($dimptx / 72.27) * 25.4;
    $dimy = ($dimpty / 72.27) * 25.4;
    ### puis on tronque
    $dimx = (int ($dimx * 100)) / 100;
    $dimy = (int ($dimy * 100)) / 100;
    print "%% xsize: $dimx mm, $dimptx pt\n";
    print "%% ysize: $dimy mm, $dimpty pt\n";
    print "\\psset{unit=1pt}\n";
    if ($sortiepst) {
    	print "\\pspicture($botx,$boty)($topx,$topy)\n";
    	print "\\psset{xunit=$PSTxunit,yunit=$PSTyunit}\n";
    	print "\\rput($PSTOx,$PSTOy){\\epsfbox{img}}\n";
    	print "\\endpspicture\n";
    }
    else {
    	print "\\begin{pspicture}($botx,$boty)($topx,$topy)\n";
    	print "\\psset{xunit=$PSTxunit,yunit=$PSTyunit}\n";
    	print "\\rput($PSTOx,$PSTOy){\\includegraphics{img}}\n";
    	print "\\end{pspicture}\n";
    }
}

##### ##### ##### ##### ##### ##### ##### ##### 
##### 
##### On imprime les en-tetes et le minimum
##### 
##### ##### ##### ##### ##### ##### ##### ##### 

## if ($sortieimposee) {
##     $sortie = $source;
##     $sortie =~ s/\.jps/\.ps/;
##     open (SORTIE, ">$sortie") or die "ouverture du fichier $sortie impossible";
##     select (SORTIE);
## }

$tmp_sortie = $JPS2PS_DIR . "tmp/XXX.ps";
$log = $JPS2PS_DIR . "tmp/XXX.log";
open (SORTIE, ">$tmp_sortie") or die "ouverture du fichier $tmp_sortie impossible";
select (SORTIE);

## #print "%!PS-Adobe-3.0 EPSF \n";
## print "%%Title:  \n";
## print "%%Creator: $version \n";
## print "%%Pages:  1 \n";
## ## print "%%BoundingBox: 0 0 $bbx $bby \n";
## #print "%%BoundingBox: $dlx $dly $urx $ury \n";
## print "%%DocumentNeededResources: font Courier \n";
## print "%%+ font Times-Roman \n";
print "%%Pspicture: ($botx,$boty)($topx,$topy)\n";
print "%%PSTunit: xunit=$PSTxunit,yunit=$PSTyunit\n";
print "%%OriginePspicture: ($PSTOx,$PSTOy)\n";
print "%%EndComments \n";
print "%%Page: 1 1\n";

##### ##### ##### ##### ##### ##### ##### ##### 
##### 
##### On ouvre un nouveau dictionnaire
##### 
##### ##### ##### ##### ##### ##### ##### ##### 

print "/Pictdic 50 dict def Pictdic begin \n";
print "gsave \n";
print "136 dict begin \n";
print "/setrotate {pop} def\n";
print "/setformat {pop} def\n";
print "/setxyrapport {pop} def\n";
print "$rotate rotate\n";

##### ##### ##### ##### ##### ##### ##### ##### 
##### 
##### On imprime les cles particulieres
##### 
##### ##### ##### ##### ##### ##### ##### ##### 

print ("%%%%%%%%%%%%%%%%%%%% la BoundingBox %%%%%%%%%%%%%%%%%%%%%\n");

if ($besoin {setwidth}) {
    print (`cat ${setwidth}`);
    }
if ($besoin {setheight}) {
    print (`cat ${setheight}`);
    }
if ($besoin {setborder}) {
    print (`cat ${setborder}`);
    }
print $width_str;
print $height_str;
print $border_str;

print ("%%%%%%%%%%%%%%%% les bornes sur les axes %%%%%%%%%%%%%%%%\n");

print $xmin_str;
print $xmax_str;
print $ymin_str;
print $ymax_str;

if ($besoin {setxrange}) {
    print (`cat ${setxrange}`);
    print $setxrange_str;}
if ($besoin {setyrange}) {
    print (`cat ${setyrange}`);
    print $setyrange_str;}

print ("/angle_repere " . $angle_repere . " def\n");
print `cat $mulv`;
print `cat $addv`;
print `cat $base_01`;
print `cat $base_02`;
print `cat $math`;
print `cat $masque`;
#print ("masque\n");

## print ("newpath\n");
## print ("$border $border moveto\n");
## print ($bbx-2*$border . " 0 rlineto\n");
## print ("0 " . $bby-2*$border . " lineto\n");
## print (-$bbx+2*$border . " 0 rlineto\n");
## print ("closepath\n");
## print ("clip\n");

## ##### impression pour deboguage
## 
## print "%%%% le test : $dependances{xtick}[0] \n";
## 
## print "%" x 20 . " mots cles recherches " . "=" x 20 . "\n";
## 
## foreach $word (@cles) {
##     print "%%% $word\n";                                 ## le mot cle
##     print "%%%    ==> "."@{ $dependances {$word} }"." \n";   ## le tableau des dependances
##     print "%%%    ==> ";
##     foreach $dep (@{ $dependances {$word} }) {               ## les elts du tableau des deps
##     print "$dep ";}
##     print "\n";
## }
## 
## print "=" x 40 . "\n";

##### ##### ##### ##### ##### ##### ##### ##### 
#####
##### impression pour deboguage
#####
##### ##### ##### ##### ##### ##### ##### ##### 

### print "\n";
### 
### ## 
### ## 
## print "%%%%% ======= on trouve =======\n";
## print '%' x 80 . "\n";
## 
## foreach $word (sort (@cles)) {
##    print "%% " . "$word   " . $besoin {$word} . "\n";
## }

##### ##### ##### ##### ##### ##### ##### ##### 
#####
##### puis on imprime ce dont on a besoin
#####
##### ##### ##### ##### ##### ##### ##### ##### 

foreach $word (sort (@cles)) {
   if ($besoin {$word}) {print (`cat ${$word}`)};
}
print "\n";

##### puis on imprime le source ## en omettant les cles particulieres
open (FICHIER, $source) or die "ouverture du fichier $source impossible";

## while (<FICHIER>) {
##     if (not ($_ =~ /^\/(xmin|xmax|ymin|ymax)/)) {print $_;};
## }

$label_en_cours = 0;
$label_tex = "";

foreach $ligne (@le_source) {
#while ($ligne = <FICHIER>) {
    if ($ligne =~ /<tex>/) {
        $label_en_cours = 1;
    };
    if (not $label_en_cours) {
        print ($ligne);
    } else {
        $label_tex = $label_tex . $ligne;
    };
    if ($ligne =~ /<\/tex>/) {
        $label_en_cours = 0;
        ($inclusion, $dim_label) = &traite_label ($label_tex);
        print ($inclusion);
        print ($dim_label);
        $label_tex = "";
    };
}

##### et la conclusion
print "\n";
print "end\n";      ### fermeture du dictionnaire principal
print "grestore\n";
print "end\n";      ### fermeture du dictionnaire Pictdic
print `cat $base_end`;

if ($sortieimposee) {
    close (SORTIE);
}
close (SORTIE);

`gs -sDEVICE=bbox -dNOPAUSE -dBATCH -q $tmp_sortie &> $log`;
$bbox = `cat $log | grep "%%BoundingBox"`;

if ($sortieimposee) {
    $sortie = $source;
    $sortie =~ s/\.jps/\.ps/;
    open (SORTIE, ">$sortie") or die "ouverture du fichier $sortie impossible";
    select (SORTIE);
} else {
    select (STDOUT);
};


print "%!PS-Adobe-3.0 EPSF \n";
print "%%Title:  \n";
print "%%Creator: $version \n";
print "%%Pages:  1 \n";
## print "%%BoundingBox: 0 0 $bbx $bby \n";
#print "%%BoundingBox: $dlx $dly $urx $ury \n";
#print "%%DocumentNeededResources: font Courier \n";
#print "%%+ font Times-Roman \n";
print "$bbox";
print (`cat $tmp_sortie`);

exit (0);

